package com.jakubu9333.grammarManager.model;


import com.fasterxml.jackson.annotation.JsonView;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;

/**
 * @author Jakub Uhlarik
 */
@Entity
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
public class Rule {

    @Id
    @JsonView(View.All.class)
    @SequenceGenerator(name = "rule_sequence", allocationSize = 1, sequenceName = "rule_sequence")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "rule_sequence")
    private Long id;

    @ManyToOne
    @JsonView(View.GrammarWithoutRules.class)
    Grammar grammar;


    public Rule(Grammar grammar, String leftSymbol, String rightSide, Boolean isRoot) {
        this.root = isRoot != null && isRoot;
        this.grammar = grammar;
        this.leftSymbol = leftSymbol;
        this.rightSide = rightSide;
    }

    @JsonView(View.All.class)
    private String leftSymbol;
    @JsonView(View.All.class)
    private String rightSide;

    @JsonView(View.All.class)
    private Boolean root;

    public Rule(Rule rule) {
        this.root = false;
        this.id = null;
        this.grammar = rule.getGrammar();
        this.leftSymbol = rule.leftSymbol;
        this.rightSide = rule.getRightSide();
    }
}
