export function RuleListInput({ rules, setRules, setRoot }) {
  const setleftSymbol = (index, leftSymbol) => {
    setRules(
      rules.map((rule, indexIndide) =>
        indexIndide == index ? { ...rule, leftSymbol: leftSymbol } : rule
      )
    );
  };
  const setrightSide = (index, rightSide) => {
    setRules(
      rules.map((rule, indexIndide) =>
        indexIndide == index ? { ...rule, rightSide: rightSide } : rule
      )
    );
  };
  return (
    <>
      <input type="radio" id="no root" name="root" />
      <label
        className="smallText"
        htmlFor="no root"
        onClick={() => setRoot(-1)}
      >
        No root
      </label>
      {rules.map((rule, index) => (
        <div key={index}>
          <input
            type="radio"
            id={index}
            name="root"
            onClick={() => setRoot(index)}
          />
          <input
            onChange={(e) => {
              setleftSymbol(index, e.target.value);
            }}
            className="transparent"
            type="text"
            placeholder="Set left symbol"
          />
          =
          <input
            onChange={(e) => {
              setrightSide(index, e.target.value);
            }}
            className="transparent"
            type="text"
            placeholder="Set right side"
          />
        </div>
      ))}
    </>
  );
}

export default RuleListInput;
